/* Projekt 2. - Binarny problem plecakowy - TPI 
   Autor: Dawid Pichen
   e-mail: dawidpichen@klub.chip.pl

   Jesli program ma wypisywac zawartosci wszystkich tabel, tzn. 
   tabelice wylosowanych elementw, tablice glwna dla algorytmu
   rozwiazania problemu plecakowego, jak rwniez wypisac indeksy
   elementw zabranych do plecaka, to prosze usunac komentarz 
   z ponizszej makrodefinicji.
*/

/* #define POKAZUJ_WSZYSTKO */

#include "pp.h"
#include "czas.h"

int main (void)
{ unsigned int ilosc[] = {10, 50, 100, 500, 1000, 5000, 10000, 25000, 50000, 75000, 100000, 0 }; //tablica ilosci elementw w magazynie
unsigned int V[] = { 10, 20, 30, 40, 50, 60, 70, 80, 90, 100, 0 }; //tablica pojemnosci plecakw
unsigned char i=0, indeks=0, indeksV=0;
struct timeval start, stop; //struktura timeval okrelona w plikach naglwkowych jdra
float *zmierzone_czasy, wynik;
FILE *plik;
Element *magazyn;	//tablica przechowujaca informacje o dostepnych elementach (rozmiar i waga)
ElementTabeli **TablicaRobocza;		//tablica uzywana przy rozwiazywaniu PP
while (V[indeksV]) indeksV++;
zmierzone_czasy = (float*) malloc(indeksV*L_PROB*sizeof(float));

if (!(plik=fopen("wynik.txt","w"))) { 
	printf("\a\nWystpi bd otwarcia pliku do zapisu!");
	return 1;
}
fprintf(plik, "Legenda: j - liczba elementw w magazynie\n");
srand(time(0));
while (ilosc[indeks])	//gwna petla programu
{ printf("\n\n##### Ilosc elementw w magazynie %u #####", ilosc[indeks]);
magazyn = (Element*) malloc(ilosc[indeks]*sizeof(Element));
if (!magazyn) { printf("\a\nBd alokacji pamici!");
		return 1; }

for (i=0; i<L_PROB; i++)	//L_PROB zdefiniowane w czas.h
{ printf("\n*** Prba nr %d ***",i); 
  WypelnijMagazyn(magazyn, ilosc[indeks]);
  #ifdef POKAZUJ_WSZYSTKO
  PokazZawartoscMagazynu(magazyn, ilosc[indeks]);
  #endif
  indeksV=0;
  while (V[indeksV])
  	{ TablicaRobocza = AlokujTabliceAlgorytmu(V[indeksV], ilosc[indeks]);
	if (!TablicaRobocza) { printf("\a\nBd alokacji pamici!"); return 1; }
	gettimeofday(&start, NULL); //pobierz aktualny czas
	BudujTabliceAlgorytmu(TablicaRobocza, magazyn, V[indeksV], ilosc[indeks]);
	#ifndef POKAZUJ_WSZYSTKO
	PokazElementyPlecaka(TablicaRobocza, magazyn, V[indeksV], ilosc[indeks]);
	#endif
	gettimeofday(&stop, NULL);
	zmierzone_czasy[L_PROB*indeksV+i]=roznica(start, stop);
	printf("\nCzas dzialania alg. pojemnosci plecaka %u: %f s.",V[indeksV],zmierzone_czasy[L_PROB*indeksV+i]);
	#ifdef POKAZUJ_WSZYSTKO
	PokazTabliceAlgorytmu(TablicaRobocza, V[indeksV], ilosc[indeks]);
	printf("\nIndeksy elementw znajdujcych si w plecaku:\n");
	PokazElementyPlecaka(TablicaRobocza, magazyn, V[indeksV], ilosc[indeks]);
	#endif
	
	ZwolnijTabliceAlgorytmu(TablicaRobocza, V[indeksV]);
	indeksV++;
	}
  
}
printf("\n\n***** CZASY REDNIE DZIAANIA ALGORYTMU DLA MAGAZYNU %u ELEMENTOWEGO *****",ilosc[indeks]);
fprintf(plik, "\nj = %u:", ilosc[indeks]);
indeksV=0;
while (V[indeksV])
	{ wynik = srednia(zmierzone_czasy, indeksV);
	printf("\nDla poj. plecaka %u: %f sekund.",V[indeksV], wynik);
	fprintf(plik, "\nV=%u -> %f sekund", V[indeksV], wynik);
	indeksV++;
	};

free(magazyn);
indeks++;
}
fprintf(plik, "\n\n(C) 2005 Dawid Pichen.");
fclose(plik);
free(zmierzone_czasy);
return 0;
} 

